
#include "stdafx.h"
#include "element.h"
#include "element_list.h"

element::element(unsigned value)
   : value_(value)
{
   if (is_ref())
      as_ref()->add_ref();
}

element::~element()
{
   if (is_ref())
      as_ref()->release();
}

element::element(element const & e)
{
   value_ = e.value_;
   if (is_ref())
      as_ref()->add_ref();
}

element & element::operator=(element const & e)
{
   element t(e);
   swap(t);
   return *this;
}

bool element::is_combinator() const
{
   return (int)value_ < 0;
}

bool element::is_argument() const
{
   return value_ < 0x40000;
}

bool element::is_ref() const
{
   return (int)value_ >= 0x40000;
}

unsigned element::as_combinator() const
{
   assert(is_combinator());
   return value_ - 0x80000000;
}

unsigned element::as_argument() const
{
   assert(is_argument());
   return value_;
}

element_list * element::as_ref() const
{
   assert(is_ref());
   return (element_list *)value_;
}

element element::combinator(unsigned u)
{
   assert(u < 0x80000000);
   return element(u + 0x80000000);
}

element element::argument(unsigned u)
{
   assert(u < 0x40000);
   return element(u);
}

element element::ref(element_list * u)
{
   assert((int)u >= 0x40000);
   return element(unsigned(u));
}

void element::swap(element & e)
{
   std::swap(value_, e.value_);
}
