
#pragma once

struct element_list;

struct element
{
   element(element const &);
   ~element();

   element & operator=(element const &);

   bool is_combinator() const;
   bool is_argument() const;
   bool is_ref() const;

   unsigned as_combinator() const;
   unsigned as_argument() const;
   element_list * as_ref() const;

   static element combinator(unsigned u);
   static element argument(unsigned u);
   static element ref(element_list * u);

   void swap(element & e);

private:
   element(unsigned value);

private:
   unsigned value_;
};
